using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace XNA_Gestures1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        //Die Kreis Textur
        Texture2D kreistextur;
        //Eine Klasse die die Kreisoptionen enthält
        class Kreis
        {
            //Konstruktor
            public Kreis(Vector2 pos)
            {
                //Die Position für den Kreis abspeichern
                position = pos;
                //Eine Farbe vergeben
                Recolor();
            }
            //Für die Gesten prüfen ob der Berührungspunkt innerhalb des Kreises ist
            public bool HitTest(Vector2 pos,Texture2D texture)
            {
                Rectangle rc = new Rectangle((int)position.X, (int)position.Y, texture.Width, texture.Height);
                if (rc.Contains((int)pos.X, (int)pos.Y))
                    return true;
                else
                    return false;
            }
            //Farbwechsel durchführen
            public void Recolor()
            {
                Random rnd = new Random();
                kreisfarbe = new Color(rnd.Next(255), rnd.Next(255), rnd.Next(255));
            }
            //Die Position des Kreises
            public Vector2 position;
            //Die Frabe des Kreises
            public Color kreisfarbe;
        }
        //Eine Liste zum abspeichern aller Kreise
        List<Kreis> kreise = new List<Kreis>();

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            //Desn gesamten Bildschirm ausnutzen
            graphics.IsFullScreen = true;
            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            /*
             * Tap zum erstellen eine Kreise
             * Double Tap zum Farbwechel
             * Hold zum entfernen des Kreises
            */
            TouchPanel.EnabledGestures = GestureType.Tap | GestureType.DoubleTap | GestureType.Hold;
            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            //Die Basistextur des Kreises laden
            kreistextur = Content.Load<Texture2D>("Kreis");
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            //Alle aktuell vorhanden gesten auswerten
            while (TouchPanel.IsGestureAvailable)
            {
                //Die aktuelle Geste auslesen
                GestureSample curGesture = TouchPanel.ReadGesture();
                //Gestentyp prüfen
                switch (curGesture.GestureType)
                {
                    //Tap: Sofern an dem Berührunsgpunkt kein Kreis existiert einen neuen Kreis erstellen
                    case GestureType.Tap:
                        {
                            bool found = false;
                            //Alle existierenden Kreise durchsuchen
                            foreach (Kreis kr in kreise)
                            {
                                //Ist der Berührunsgpunkt im Kreis?
                                if (kr.HitTest(curGesture.Position,kreistextur))
                                {
                                    //Ja, dann ignorieren
                                    found = true;
                                    break;
                                }
                            }
                            //Nein, einen neuen Kreis erstellen
                            if (!found)
                                kreise.Add(new Kreis(curGesture.Position));
                        }
                        break;
                    //Double Tap: Sofern an dem Berührunsgpunkt ein Kreis existiert die Farbe ändern
                    case GestureType.DoubleTap:
                        {
                            //Alle existierenden Kreise durchsuchen
                            foreach (Kreis kr in kreise)
                            {
                                //Ist der Berührunsgpunkt im Kreis?
                                if (kr.HitTest(curGesture.Position,kreistextur))
                                {
                                    //Farbwechsel vornehmen
                                    kr.Recolor();
                                    break;
                                }
                            }
                        }
                        break;
                    //Hold: Sofern an dem Berührunsgpunkt ein Kreis existiert diesen löschen
                    case GestureType.Hold:
                        {
                            //Alle existierenden Kreise durchsuchen
                            foreach (Kreis kr in kreise)
                            {
                                //Ist der Berührunsgpunkt im Kreis?
                                if (kr.HitTest(curGesture.Position, kreistextur))
                                {
                                    //Ja, entfernen
                                    kreise.Remove(kr);
                                    break;
                                }
                            }
                        }
                        break;
                }
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.White);
            //Jetzt alle in der Liste vorhandenen Kreise zeichen
            spriteBatch.Begin();
            foreach (Kreis kr in kreise)
            {
                spriteBatch.Draw(kreistextur, kr.position, kr.kreisfarbe);
            }
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
